package com.jscape.inet.sftp.protocol.v3.marshaling;

import com.jscape.inet.sftp.protocol.messages.Message;
import com.jscape.inet.sftp.protocol.v3.messages.FileAttributes;
import com.jscape.inet.sftp.protocol.v3.messages.SshFxpSetStat;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.StringCodec;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.Uint32Codec;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Alex Usun
 */
public class SshFxpSetStatCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        int id = Uint32Codec.readValue(in);
        String path = StringCodec.readUtf8Value(in);
        FileAttributes attributes = FileAttributesCodec.readValue(in);

        return new SshFxpSetStat(id, path, attributes);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshFxpSetStat message = (SshFxpSetStat) value;
        Uint32Codec.writeValue(message.id, out);
        StringCodec.writeUtf8Value(message.path, out);
        FileAttributesCodec.writeValue(message.attributes, out);
    }

}
